/*
 * This will probably do you no good, it was a test for a array of
 * LED's I was testing, lots of output latches X and Y then you
 * made one bit high on X the other low on Y and the LED would light up
*/
/* we use a 32K EPROM, this sets up for "zend.h" file */
#define ROM32K

/* put this in when you are downloading to RAM */
/*ramjump()
{
#asm
	clra
	clrb
	jmp	_main
#endasm
}*/

/* input buffer for serial ports */
#define rcvchar   *0x0006

/* you only include the files you need for your particular application */
#include "z68hc11.h"
#include "zUHCrun.h"
#include "zserial.c"
#include "zadc.c"
#include "zdelay.c"

/* globals for use by this program */

/* where the graphics table starts */
#define gra    *0x0040

/* values used by this program */



portset()
{
}

#define lights0   0x2000
#define lights1   0x2001
#define lights2   0x2002
#define lights3   0x2003
#define lights4   0x2004
#define lights5   0x2005
#define lights6   0x2006
#define temp   0x0C


main()
{
int a, x, i;
x = 0;
i = 0;

portset(); /* set the ports */
serset(0x30);  /* set up serial port, baud rate 0x33=1200 0x32=2400 0x30=9600 */

gettable(); /* get the graphics table location */

pokeb(lights0,0x00); /* turn them all off */
pokeb(lights1,0x00);
pokeb(lights2,0x00);
pokeb(lights3,0x00);
pokeb(lights6,0xFF);
serprint("]]Resetting]");

while(1)
{
if (x++ > 400) {
	if (i++ >= 2) i = 0;
	x = 0;
	}
display(i);
if (peekb(SCSR) & 0x20) break; /* this will stop if a key is pressed, serial port */
 }	
x = peekb(SCDR); /* clear out the serial character */

}

display(which) /* which is the table to use */
int which;
{
int a,b,x,y,i,col;

a = gra + (which * 56);

pokeb(lights0,0);
pokeb(lights1,0);
pokeb(lights2,0);
pokeb(lights3,0);
pokeb(lights4,0);
pokeb(lights5,0);

col = 0x80;
for (i = 0; i < 8; i++) {
	y=peekb(a++);
	pokeb(lights0,y);
	y=peekb(a++);
	pokeb(lights1,y);
	y=peekb(a++);
	pokeb(lights2,y);
	y=peekb(a++);
	pokeb(lights3,y);
	pokeb(lights4,col);
	col = (col >> 1) & 0x00FF;
	mydelay(temp);
	pokeb(lights4,0);
	}
pokeb(lights4,0);
pokeb(lights0,0);
pokeb(lights1,0);
pokeb(lights2,0);
pokeb(lights3,0);

col = 0x80;
for (i = 0; i < 6; i++) {
	y=peekb(a++);
	pokeb(lights0,y);
	y=peekb(a++);
	pokeb(lights1,y);
	y=peekb(a++);
	pokeb(lights2,y);
	y=peekb(a++);
	pokeb(lights3,y);
	pokeb(lights5,col);
	col = (col >> 1) & 0x00FF;
	mydelay(temp);
	pokeb(lights5,0);
	}
pokeb(lights5,0);
pokeb(lights0,0);
pokeb(lights1,0);
pokeb(lights2,0);
pokeb(lights3,0);
}

mydelay(time1)
int time1;
{
int i;
for (i = 0; i < time1; i++) {}
}



#include "gratables.c"




/* this is how we get our move data table into ROM, with this compiler
 * this is the best way I could figure out, just change the "FCB" numbers
 * for each move you do. You need to define the variable "moves" to access
 * the value from C. You call this once at the start to set up "moves".
*/

moveset(){
#asm
* This is a two byte location for storing the location of the start of our data table
MOVES	EQU	$40

	ldd 	#*	* load the current address pointer into d
	Addd	#9	* point to the bytes after the rts
	std	MOVES	* put it where we can use it from C
	rts

* the moves are X,Y,bits  (bits are the extra port pins)
* NEVER USE ZERO (0) as first byte, it means end of moves
*
	FCB	250,080,$00	* move to right, down, mag off
	FCB	250,080,$20	* stay, mag on
	FCB	250,128,$20	* pull up
	FCB	020,128,$20	* move left
	FCB	010,100,$20	* down a bit
	FCB	010,100,$00	* mag off
	FCB	00,00,00	* the end
	

#endasm
}



/* include this at the end of your program */

#include "zend.h"

